<?php
function action($pAction,$pArgs = null) {
	global $lDreamBoxObj, $gDebugObj, $gSetupObj, $gUpdateObj;
	$pAction = trim($pAction);
	if ($pAction == "") return false;
	if (!is_array($pArgs)) $pArgs = explode(",",$pArgs);
	$lReturnValue = new xajaxResponse();

	switch ($pAction) {
		case 'initRestream';
			if ($gSetupObj->configOutDated()) {
				$lReturnValue->script("loadChannelList()");
				$lReturnValue->script("jQuery('#ProgramProgress').progressbar({value: 0})");
				$lReturnValue->script("jQuery('#message').html('<p>' + jQuery('#ReStreamPlayer p').html() + '</p>')");
			} else {
				// Clear the session cache
				if (Settings::getDebug()) unset($_SESSION["ReStream2.0"]["Dreambox"]);
				if ($lDreamBoxObj->isOnline()) {
					$lReturnValue->script("DreamboxObj.dialog('Loading dreambox<br />Loading bouquets....')");
					$lReturnValue->script('DreamboxObj.loadBouquets()');
				} else {
					$lReturnValue->script("DreamboxObj.dialog('Loading dreambox<br /><span class=\"error\">The Dreambox is currently offline!</span>')");
					$lReturnValue->script("setTimeout(function() { DreamboxObj.loadMovies() } , 2000)");	
				}
			}
		break;
		
		case 'loadBouqetData':
			$lDreamBoxObj->loadBouquets();
			foreach($lDreamBoxObj->getBouquets() as $lBouquet) {
				$lReturnValue->script("DreamboxObj.addBouquet('" . Utils::JSSave($lBouquet->getID()) . "','" . Utils::JSSave($lBouquet->getName()) . "')");
			}
			$lReturnValue->script('DreamboxObj.showBouquets()');
			$lReturnValue->script("DreamboxObj.dialog('Loading dreambox<br />Loading bouquets.... done!<br />Loading channels....')");
			$lReturnValue->script('DreamboxObj.loadChannels()');
			
			$lReturnValue->script('DreamboxObj.loadRecordings()');
		break;
		
		case 'loadChannelData':
			if (substr($pArgs[0],0,1) != '_') {
				$lDreamBoxObj->loadChannel($pArgs[0]);
				$lBouquetObj = $lDreamBoxObj->getBouquet($pArgs[0]);
				if ($lBouquetObj !== false) {
					foreach($lBouquetObj->getChannels() as $lChannelObj) {
						$lReturnValue->script("DreamboxObj.addChannel('" . Utils::JSSave($lChannelObj->getID()) . "','" . Utils::JSSave($lBouquetObj->getID()) . "','" . Utils::JSSave($lChannelObj->getName()) . "','" . ($lChannelObj->isMarker() ? 'marker' : 'channel') . "')");
					}
					$lReturnValue->script("DreamboxObj.showChannels('" . Utils::JSSave($lBouquetObj->getID()) . "')");
				}
			}
			$lReturnValue->script('DreamboxObj.loadChannels()');
		break;

		case 'loadRecordingData':
			$lDreamBoxObj->loadRecordings();
			foreach($lDreamBoxObj->getRecordings() as $lRecording) { //id,name,date,channel,duration,description,long_description,filesize
				$lReturnValue->script("DreamboxObj.addRecording('" . Utils::JSSave($lRecording->getID()) . "','" . Utils::JSSave($lRecording->getName()) . "'," . Utils::JSSave($lRecording->getStartTime()) . ",'" . Utils::JSSave($lRecording->getServiceName()) . "'," . Utils::JSSave($lRecording->getDuration()) . ",'" . Utils::JSSave($lRecording->getDescription()) . "','" . Utils::JSSave($lRecording->getLongDescription()) . "'," . Utils::JSSave($lRecording->getFileSize()) . ")");
			}
			$lReturnValue->script('DreamboxObj.showRecordings()');
			$lReturnValue->script("DreamboxObj.dialog('Loading dreambox<br />Loading bouquets.... done!<br />Loading channels.... done!<br />Loading recordings.... done!<br />Loading movies....')");
			$lReturnValue->script('DreamboxObj.loadMovies()');	
		break;
		
		case 'loadMovieData':
			$lDreamBoxObj->loadMovies();
			foreach($lDreamBoxObj->getMovies() as $lMovie) {
				$lReturnValue->script("DreamboxObj.addMovie('" . Utils::JSSave($lMovie->getID()) . "','" . Utils::JSSave($lMovie->getName()) . "'," . $lMovie->getDuration() . "," . $lMovie->getFileSize() . "," . $lMovie->getBitrate() . ",'" . $lMovie->getResolution() . "',new Array('" . implode($lMovie->getAvailableSubtitleLanguages(),"','"). "'))");
			}
			$lReturnValue->script('DreamboxObj.showMovies()');
			$lReturnValue->script("DreamboxObj.dialog('Loading dreambox<br />Loading bouquets.... done!<br />Loading channels.... done!<br />Loading recordings.... done!<br />Loading movies.... done!')");
			$lReturnValue->script('DreamboxObj.start()');
		break;
		
		case 'loadNowAndNextEPGData':
			$lDreamBoxObj->loadCurrentAndNextEPG();
			foreach($lDreamBoxObj->getBouquets() as $lBouquet) {
				foreach($lBouquet->getChannels() as $lChannel) {
					$lGuide = $lDreamBoxObj->getProgramGuide($lChannel->getID());
					if ($lGuide !== false) {
						foreach($lGuide->getPrograms() as $lProgram) {
							$lTitle = Utils::JSSave($lProgram->getTitle());
							$lDescription = Utils::JSSave(nl2br(Utils::parseUrls($lProgram->getDescription())));
							$lReturnValue->script("DreamboxObj.addProgram('" . $lProgram->getID() . "','" . $lChannel->getID() . "','" . $lTitle . "','" . $lProgram->getStartTime() . "','" . $lProgram->getStopTime() . "','" . $lDescription . "')");
						}
					}
				}
			}
			$lReturnValue->script('DreamboxObj.showCurrentPrograms()');
			if ((Utils::isMobileDevice() && getAutoLoadEPG()) || !Utils::isMobileDevice()) $lReturnValue->script('DreamboxObj.loadPrograms()');
		break;

		case 'loadChannelEPGData':
			$lDreamBoxObj->loadProgramGuide($pArgs[0]);
			$lGuide = $lDreamBoxObj->getProgramGuide($pArgs[0]);
			if ($lGuide !== false) {
				foreach($lGuide->getPrograms() as $lProgram) {
					$lTitle = Utils::JSSave($lProgram->getTitle());
					$lDescription = Utils::JSSave(nl2br(Utils::parseUrls($lProgram->getDescription())));
					if (strlen($lProgram->getLongDescription()) > strlen($lProgram->getDescription())) $lDescription = Utils::JSSave(nl2br(Utils::parseUrls($lProgram->getLongDescription())));
					$lReturnValue->script("DreamboxObj.addProgram('" . $lProgram->getID() . "','" . $pArgs[0] . "','" . $lTitle . "','" . $lProgram->getStartTime() . "','" . $lProgram->getStopTime() . "','" . $lDescription . "')");
				}
			}
			$lReturnValue->script('DreamboxObj.loadPrograms()');
		break;
		
		case 'startWatching':
			if (Settings::getMoviesPath() != "" && substr($pArgs[0],0,strlen(Settings::getMoviesPath())) == Settings::getMoviesPath()) {
				$lChannelObj = $lDreamBoxObj->getMovie($pArgs[0]);
			} elseif (substr($pArgs[0],-3) == ".ts") {
				$lChannelObj = $lDreamBoxObj->findRecording($pArgs[0]);
			} else {
				$lChannelObj = $lDreamBoxObj->findChannel($pArgs[0]);
			}
	
			$lVLCObj = new VLCServer();
			$lPlayerCMD = $lVLCObj->startServer($lDreamBoxObj->getStreamURL($pArgs[0]),$lChannelObj);
			$lReturnValue->script("DreamboxObj.play('" . $lPlayerCMD . "')");
			$lReturnValue->script("DreamboxObj.encodingStatus('" . Utils::JSSave($pArgs[0]) . "')");
			$lReturnValue->script("DreamboxObj.showActiveChannelImage('" . $lDreamBoxObj->getChannelImage($pArgs[0]). "')");
			$lReturnValue->script('DreamboxObj.startProgressBar()');
		break;
		
		case 'stopWatching':
			$lVLCObj = new VLCServer();
			$lVLCObj->stopServer();
			$lReturnValue->script("DreamboxObj.encodingStatus('')");
		break;
		
		case 'encodingStatus' :
			$lVLCObj = new VLCServer();
			$lVLCData = $lVLCObj->getCurrentStatus();
			$lReturnValue->script("DreamboxObj.encodingStatus('" . Utils::JSSave($lVLCData["channel"]) . "')");
		break;
		
		
		
	
	
	
		case 'saveMobileOptions':
			$lReturnValue = processMobileOptions($pArgs);
		break;
		


		case 'updateConfig':
			$lReturnValue = $gSetupObj->updateSettings($pArgs);
		break;
		
		
		case "updateSoftware":
			$lReturnValue = $gUpdateObj->runUpdate();
		break;
		
		
		
	}
	
	if (!$gSetupObj->configOutDated() && Settings::getDebug()) {
		if ($gDebugObj->getDebugMessage() != "") {
			$lReturnValue->prepend("errorLog","innerHTML",$gDebugObj->getDebugMessage());
		}
	}
	return $lReturnValue;
}

// Mobile functions
function processMobileOptions($pFormData) {
	setMobileOption("autoLoadEPG",($pFormData["autoLoadEPG"] == "on" ? 1 : 0));
	if (!empty($pFormData["privateModusUserName"])) setMobileOption("privateModusUserName",$pFormData["privateModusUserName"]);
	if (!empty($pFormData["privateModusPassword"])) setMobileOption("privateModusPassword",$pFormData["privateModusPassword"]);
	$lAjaxResponse  = new xajaxResponse();
	$lAjaxResponse->script("jQuery('.ui-dialog').dialog('close')");
	if ($pFormData["autoLoadEPG"] == "on" && getMobileOption('autoLoadEPG') != 'on') $lAjaxResponse->script("location.reload();");
	return $lAjaxResponse;
}

function setMobileOption($pParam,$pValue) {
	$pParam = trim($pParam);
	if ($pParam == "") return;
	$lOptions = loadMobileOptions();
	switch ($pParam) {
		case "autoLoadEPG":
			$lOptions[$pParam] = $pValue;
		break;
		case "privateModusUserName":
			$lOptions[$pParam] = $pValue;
		break;
		case "privateModusPassword":
			$lOptions[$pParam] = $pValue;
		break;
	}
	saveMobileOptions($lOptions);
}

function getMobileOption($pParam) {
	$pParam = trim($pParam);
	if ($pParam == "") return;
	$lOptions = loadMobileOptions();
	$lValue = "";
	if (isset($lOptions[$pParam])) $lValue = trim($lOptions[$pParam]);
	return $lValue;
}

function loadMobileOptions() {
	$lOptions = array();
	if (!isset($_COOKIE["ReStream"])) return $lOptions;
	$lData = explode("|",$_COOKIE["ReStream"]);
	foreach ($lData as $lOption) {
		$lOption = explode("=",$lOption);
		if (trim($lOption[0]) != "") {
			$lOptions[trim($lOption[0])] = trim($lOption[1]);
		}
	}
	return $lOptions;
}

function saveMobileOptions($pOptions) {
	$lCookieData = array();
	foreach ($pOptions as $lParam => $lValue) {
		$lCookieData[] = $lParam . "=" . $lValue;
	}
	setcookie("ReStream",implode("|",$lCookieData), time()+(3600*24*30)); // 1 month
}

function setAutoLoadEPG($pOn = "") {
	$pOn = (strtolower($pOn) == "on");
	setMobileOption("autoLoadEPG",($pOn ? 1 : 0));
	$lAjaxResponse  = new xajaxResponse();
	return $lAjaxResponse;
}

function getAutoLoadEPG() {
	return getMobileOption("autoLoadEPG") == 1;
}